package com.lemoulinstudio.jnag.rds;

import com.sun.sgs.app.AppContext;
import com.sun.sgs.app.DataManager;
import com.sun.sgs.app.ManagedObject;
import com.sun.sgs.app.ManagedReference;
import java.io.Serializable;
import com.lemoulinstudio.jnag.common.Remote;

/**
 * The super type of all the proxy classes generated by the annotation processor.
 *
 * The generic type is only here to simplify the reading of the source code
 * and to help users avoid bugs in their code.
 *
 * @author Vincent Cantin
 */
public class Proxy<T extends Remote> implements ManagedObject, Serializable {
  
  private static final long serialVersionUID = 1L;
  
  protected final ManagedReference<JnagSessionImpl> jnagSessionRef;
  protected final ManagedReference<T> thisRef;

  public Proxy(JnagSessionImpl jnagSession) {
    DataManager dataManager = AppContext.getDataManager();
    jnagSessionRef = dataManager.createReference(jnagSession);
    thisRef = dataManager.createReference((T) this);
  }

}
