package com.lemoulinstudio.jnag.rds;

import com.sun.sgs.app.AppContext;
import com.sun.sgs.app.ManagedObjectRemoval;
import com.sun.sgs.app.ManagedReference;
import com.sun.sgs.app.util.ScalableDeque;
import java.io.Serializable;

/**
 *
 * @author Vincent Cantin
 */
class SharedIdStore implements LocalIdStore, ManagedObjectRemoval, Serializable {

  private static final long serialVersionUID = 1L;

  private ManagedReference<ScalableDeque<Id>> recycledIdStackRef;
  private int nextIdValue;

  public SharedIdStore() {
    recycledIdStackRef = AppContext.getDataManager().createReference(new ScalableDeque<Id>());
    nextIdValue = 0;
  }

  @Override
  public Id createId() {
    if (recycledIdStackRef.get().isEmpty()) return new Id(nextIdValue++);
    else return recycledIdStackRef.get().pop();
  }

  @Override
  public void releaseId(Id id) {
    recycledIdStackRef.get().push(id);
  }

  @Override
  public void removingObject() {
    AppContext.getDataManager().removeObject(recycledIdStackRef);
  }
  
}
